<?php
   $guessingOn = true; // turn this to false to disable guessing
   $default_data = array( "admin" => 
                         array( 
                               "pass" => "passw0rd", 
                               "update" => -1,
                               "weigth" => -1,
                               "date" => -1,
                               "minute" => -1
                               )
                        );
   $GLOBALS['admins']=array( 'admin', 'Scott Moser', 'Suzanne Moser');
   $GLOBALS['form_action']="http://smoser.brickies.net/baby_pool/myPool.php";
   $urlSource = '';           // change from '' to '../' when archiving

   putenv("TZ=US/Central"); 

   $storage= $urlSource . "./poolData.txt";

   $GLOBALS['date_start']=strtotime("Jan 6, 2008 00:00 CST");
   $GLOBALS['date_end']=strtotime("Jan 22, 2008 23:59 CST");
   $GLOBALS['date_increment']=(60*60*8);

   $GLOBALS['weight_start']=(6*16);
   $GLOBALS['weight_end']=(14*16);
   $GLOBALS['weight_increment']=1;

   $GLOBALS['minute_start']=0;
   $GLOBALS['minute_end']=(24*60);
   $GLOBALS['minute_increment']=1;

   # globals used for text
   $baby_name="Sienna"; $GLOBALS['baby_name']=$baby_name;

   $GLOBALS['date_greeting']="When will $baby_name be born?";
   $GLOBALS['date_hint']="The official due date is January 22.";
   $GLOBALS['weight_greeting']="How much will $baby_name weigh at birth?";
   $GLOBALS['weight_hint']="Eli (Sienna's big brother) was born at 9 pounds and 1 ounce.";
   $GLOBALS['prize_info']="The persons guessing closest to ${baby_name}'s actual birth date and time will win a $25 giftcard for Border's Books or AMC Theaters. The individual guessing the closest to ${baby_name}'s actual birth weight will win a gift card to a restauraunt in the the amount of her birth weight (ie 9 lbs 1 oz = \$9.01). </span>\n";
   $GLOBALS['minute_greeting']="What exact minute will $baby_name be born?";
   $GLOBALS['minute_hint']="Eli (Sienna's big brother) was born at 3:15 pm";

   // these f[open,close,write] wrppers are just here because
   // inside of drupal on dreamhost, the strings would cause internal server
   // error on submit of the new page
   function do_f_open($file,$mode) {
      return(eval("return(f" . "o" . "pen(\$file,\$mode));"));
   }
   function do_f_close($fp) {
      return(eval("return(f" . "c" . "lose(\$fp));"));
   }     
   function do_f_write($fp,$data) {
      return(eval("return(f" . "w" . "rite(\$fp,\$data));"));
   }  
   function do_lock($storage,$write_lock) {
      $mode=LOCK_SH;
      if($write_lock) { $mode=LOCK_EX; }
      if(($fp=do_f_open($storage . ".lock","w"))!=false && flock($fp,$mode)) {
         global $_lock_fp;
         $_lock_fp=$fp;
         return(true);
      }
      return(false);
   }
   function do_unlock($storage) {
      global $_lock_fp;
      if(!$_lock_fp) { return(true); }
      return(@do_f_close($_lock_fp));
   }

   function writeData($storage,$data) {
      $fp=do_f_open($storage,"w");
      if(!$fp) { return(false); }
      if((do_f_write($fp,serialize($data)))!==false) {
         do_f_close($fp);
         return(true);
      }
      return(false);
   }
   function readData($storage) {
      if(file_exists($storage)) {
         return(unserialize(implode('',file($storage))));
      }
   }
   
   
   // returns an associative array with
   // if $data looks like:
   //       data[Scott Moser][weight]=10
   // then invertData($data,"weight") returns an array like:
   //       ret[10]=Scott Moser
   function invertData($data,$field) {
      $ret=array();
      foreach($data as $user => $udata) {
         if(isset($udata[$field])) { $ret[$udata[$field]]=$user; }
      }
      return($ret);
   }

   function weightTable($data,$only_set=true) {
      global $weight_start, $weight_end, $weight_increment;
      global $weight_greeting, $weight_hint;
      $weights=invertData($data,"weight");
      
      echo "<div class=\"tableTitle\">$weight_greeting<br /><span class=\"disclaimer\">$weight_hint</span></div>\n";
      echo "<table id=\"weightTable\" align=\"center\" width=\"80%\"><tr><th>Weight</th><th>Name</th>\n";
      for($i=$weight_start;$i<$weight_end;$i+=$weight_increment) {
         $name=$weights[$i];
         if($only_set && !$name) { continue; }
         if(!$name) { $name="&nbsp"; }
         echo "<tr><td nowrap=\"nowrap\">" . weightToStr($i) . 
            "</td><td nowrap=\"nowrap\">" . $name .  "</tr>\n";
      }
      echo "</table>\n";
   }

   function minuteTable($data,$only_set=true) {
      global $minute_start, $minute_end, $minute_increment;
      global $minute_hint, $minute_greeting;
      $minutes=invertData($data,"minute");
      
      echo "<div class=\"tableTitle\">$minute_greeting<br /><span class=\"disclaimer\">$minute_hint</span></div>\n";
      echo "<table id=\"dateTable\" align=\"center\" width=\"80%\"><tr><th>Minute</th><th>Name</th>\n";
      for($i=$minute_start;$i<$minute_end;$i+=$minute_increment) {
         $name=$minutes[$i];
         if($only_set && !$name) { continue; }
         if(!$name) { $name="&nbsp"; }
         echo "<tr><td nowrap=\"nowrap\">" . minuteToStr($i) . 
            "</td><td nowrap=\"nowrap\">" . $name .  "</tr>\n";
      }
      echo "</table>\n";
   }

   function weightToStr($w) {
      return(intval($w/16) . " lbs " .  ($w%16) . " oz");
   }

   function dateToStr($d) {
      return(date("D, M j, Y",$d));
   }

   function minuteToStr($d) {
      return(gmdate("g:i a",$d*60));
   }

   function timeToStr($d) {
      global $date_increment;
      return(date("g:i a",$d) . " - " . date("g:i a",$d+$date_increment-1));
   }   

   function dateTable($data,$only_set=true) {
      global $date_start, $date_end, $date_increment;
      global $date_greeting, $date_hint;
      $dates=invertData($data,"date");
      echo "<div class=\"tableTitle\">$date_greeting<br /><span class=\"disclaimer\">$date_hint</span></div>\n";
      echo "<table id=\"dateTable\" align=\"center\" width=\"80%\"><tr><th>Date</th><th>Name</th>\n";
      for($i=$date_start;$i<$date_end;$i+=$date_increment) {
         $name=$dates[$i];
         if($only_set && !$name) { continue; }
         if(!$name) { $name="&nbsp"; }
         echo "<tr><td nowrap=\"nowrap\"><table id=\"tableDates\" width=\"100%\"><tr><td nowrap=\"nowrap\">" . dateToStr($i) .
            "</td><td nowrap=\"nowrap\"><span class=\"disclaimer\">(" . timeToStr($i) . 
            ")</span></td></tr></table></td><td nowrap=\"nowrap\">" . $name .  "</tr>\n";
      }
      echo "</table>\n";
   }

   function startForm($todo,$pass=false) {
      global $form_action;
      echo "<form action='" . $form_action . "' method='post'>\n";
      if($pass) {
         echo "<input type='hidden' name='password' value='$pass'>\n";
      }
      echo "<input type='hidden' name='todo' value='$todo'>\n";
   }
   function endForm($label) {
      echo "<input type='submit' value='$label'>\n";
      echo "</form>\n";
   }
   function dateForm($data,$uname) {
      global $date_start, $date_end, $date_increment;
      $dates=invertData($data,"date");
      $str="";
      for($i=$date_start;$i<$date_end;$i+=$date_increment) {
         $name=$dates[$i];
         if($name && $name!=$uname) { continue; }
         if(!$name) { $name=""; }
         $str.="<option value=\"$i\" ";
         if($name) { $str.=" selected"; }
         $str.=">" . dateToStr($i) . " (" . timeToStr($i) . ")";
         if($name) { $str.=" [current]"; }
         $str.="\n";
      }
      if($str!=="") {
         echo "<select id=\"date\" name=\"date\">\n";
         echo "$str";
         echo "</select>\n";
      } else {
         echo "<input type=\"hidden\" name=\"date\" value=\"-1\">\n";
         echo "Sorry, there are no more dates available.<br/>";
      }
   }
   function weightForm($data,$uname) {
      global $weight_start, $weight_end, $weight_increment;
      $weights=invertData($data,"weight");
      $str="";
      for($i=$weight_start;$i<$weight_end;$i+=$weight_increment) {
         $name=$weights[$i];
         if($name && $name!=$uname) { continue; }
         if(!$name) { $name=""; }
         $str.="<option value=\"$i\" ";
         if($name) { $str.=" selected"; }
         $str.=">" . weightToStr($i);
         if($name) { $str.=" [current]"; }
         $str.="\n";
      }
      if($str!=="") {
         echo "<select id=\"weight\" name=\"weight\">\n";
         echo "$str";
         echo "</select>\n";
      } else {
         echo "<input type=\"hidden\" name=\"weight\" value=\"-1\">\n";
         echo "Sorry, there are no weights available<br/>\n";
      }
   }

   function minuteForm($data,$uname) {
      global $minute_start, $minute_end, $minute_increment;
      $minutes=invertData($data,"minute");
      echo "<select id=\"minute\" name=\"minute\">\n";
      for($i=$minute_start;$i<$minute_end;$i+=$minute_increment) {
         $name=$minutes[$i];
         if($name && $name!=$uname) { continue; }
         if(!$name) { $name=""; }
         $str="<option value=\"$i\" ";
         if($name) { $str.=" selected"; }
         $str.=">" . minuteToStr($i);
         if($name) { $str.=" [current]"; }
         $str.="\n";
         echo "$str";
      }
      echo "</select>\n";
   }

   function checkpass($data,$name,$pass){
      if(isset($data[$name]) &&
         strtolower($pass)==strtolower($data[$name]["pass"])) { return(true); }
      return(false);
   }
   function updateUser(&$data,$name,$date,$weight,$minute) {
      $dates=invertData($data,"dates");
      $weights=invertData($data,"weights");
      $minutes=invertData($data,"minutes");
      if(isset($dates[$date]) && $dates[$date]!=$name) {
         echo "date held by " . $dates[$date];
         return(false);
      }
      if(isset($weights[$weight]) && $weights[$weight]!=$name) {
         echo "weight held by " . $weights[$weight];
         return(false);
      }
      if(isset($minutes[$minute]) && $minutes[$minute]!=$name) {
         echo "time held by " . $minutes[$minute];
         return(false);
      }
      $pweight=$data[$name]["weight"];
      $pdate=$data[$name]["date"];
      $pminute=$data[$name]["minute"];

      if($pweight) { unset($data["weight"][$pweight]); }
      if($pdate) { unset($data["date"][$pdate]); }
      if($pminute) { unset($data["date"][$pminute]); }
      $data[$name]["update"]=time();
      $data[$name]["weight"]=$weight;
      $data[$name]["date"]=$date;
      $data[$name]["minute"]=$minute;
      return(true);
   }

   function isAdmin($user) {
      return(in_array($user,$GLOBALS['admins']));
   }

   function showLoginForm() {
       startForm("login","");
       echo "Name: <input type=\"text\" name=\"name\" size=\"15\" maxlength=\"25\" value=\"$name\">&nbsp;&nbsp;\n";
       echo "Favorite Color: <input type=\"text\" name=\"password\" size=\"15\" maxlength=\"25\" value=\"\">&nbsp;\n";
       endForm("Sign On");
   }

   $todo=$_REQUEST["todo"];
   if(!(do_lock($storage,$todo))) {
      echo "Failed to lock storage.<br />\n";
      return(0);
   }

?>
<link rel="stylesheet" type="text/css" href="poolStyles.css" />
<?php
   if(!($data=readData($storage))) { 
      unset($data); 
   }
   if(sizeof($data)==0) {
      $data=$default_data;
   }
   if($todo) {
      $name=$_REQUEST["name"];
      $date=$_REQUEST["date"];
      $weight=$_REQUEST["weight"];
      $minute=$_REQUEST["minute"];
      $pass=$_REQUEST["password"];
      $formAction=$_REQUEST["todo"];
      $need_update=0;
      if(!isset($data[$name])) {
         if(!$pass) { echo "'Favorite Color' may not be empty.  Please try again.<br />\n"; return(0); }
      }
      if(!(checkpass($data,$name,$pass))) {
         if(isset($data[$name])) {
            echo "Invalid favorite color entered.  Please try again.<br />\n";
            showLoginForm();
            return(0);
         } else {
            // create the user
            echo "The user $name was successfully created.<br />\n";
            echo "Please select your guess and press 'Submit Entry'.<br /><br />\n";
            $data[$name]["pass"]=$pass;
            $need_update=1;
         }
      } else {
         if ($formAction=="login") {
            echo "Hello ".$name.".<br />\n";
            echo "Please select your guess and press 'Submit Entry'.<br /><br />\n";
         } else {
            if ($formAction=="submit"){
               echo "Your guess has been saved.<br />\n";
               echo "You may sign back on to change your vote.<br /><br />\n";
            }
         }
      }
      if($todo=="login") {
         // show the form here
         echo "<div id=\"pollSelectionForm\">\n";
         startForm("submit",$pass);
         echo "<input type='hidden' name='name' value='$name'>\n";
         echo "<table border=\"0\" cellpadding=\"3\"><tr><td  class=\"disclaimer2\" colspan=\"2\">$date_hint</td></tr><tr><td align=\"right\" valign=\"middle\"><label for=\"date\">Birth Date:</label></td><td algin=\"right\" valign=\"middle\">";
         dateForm($data,$name); 
         echo "</td></tr><tr><td class=\"disclaimer2\" colspan=\"2\"><br />$weight_hint</td></tr><tr><td align=\"right\" valign=\"middle\"><label for=\"weight\">Birth Weight:</label></td><td algin=\"right\" valign=\"middle\">";
         weightForm($data,$name);
         echo "</td></tr><tr><td class=\"disclaimer2\" colspan=\"2\">&nbsp;</td></tr><tr><td align=\"right\" valign=\"middle\"><label for=\"minute\">Birth Time:</label></td><td algin=\"right\" valign=\"middle\">";
         minuteForm($data,$name);
         echo "</td></tr><tr><td colspan=\"2\" align=\"center\" valign=\"middle\">";
         endForm("Submit Entry");
         echo "</td></tr></table>";
         echo "</form>\n";
         echo "</div>\n";
      } elseif ($todo=="submit") {
         if(updateUser($data,$name,$date,$weight,$minute)) {
            $need_update=1;
         } else {
            echo "There was a problem saving your guess.<br />\n";
         }
      } elseif($todo=="do_update") {
         if(isAdmin($name)) {
            $newdata=$_REQUEST["newdata"];
            if(get_magic_quotes_gpc()) { $newdata=stripslashes($newdata); }
            // echo "<PRE>newdata=$newdata</PRE><BR>\n";
            // writeData($storage . "." . time(),$data);
            $ret=eval("return(" . $newdata . ");");
            if($ret!==false) {
               if(writeData($storage . "." . time(),$data)) {
                  $need_update=1;
                  $data=$ret;
               } else {
                  echo "failed to write backup data<BR>not updating data\n";
                  return(0);
               }
            } else {
               echo "not updating data, code errored<BR>\n";
            }
         } else {
            echo "you are not an admin<BR>\n";
         }
      } else {
         echo "Unknown submit option entered.<br />\n";
      }
      if($need_update) {
         writeData($storage,$data);
      }
   }
   do_unlock($storage);
   if(!$todo || $todo=="submit") {
     if ($guessingOn){
       if($todo!="submit") {
          echo "Please sign in with your name and favorite color to save or change your vote.<br /><br />\n";
       }
       echo "<div id=\"signOn\">\n";
       showLoginForm();
     }
   }
   dateTable($data);
   echo "<br /><br />\n";
   weightTable($data);
   echo "<br /><br />\n";
   minuteTable($data);

   echo "<br /><br/><span class=\"disclaimer\">" . $GLOBALS['prize_info'] . 
      "</span>\n";

   if(isAdmin($name) && $guessingOn) {
      startForm("do_update",$pass);
      echo "<input type='hidden' name='name' value='$name'>\n";
      echo "<TEXTAREA ROWS=15 COLS=55 name='newdata'>\n";
      echo var_export($data) ;
      echo "</TEXTAREA>\n";
      endForm("update data");
   }

?>
